#include "SafeArray3.h"
#include <iostream>
#include <cassert>

using namespace std;

int SafeArray::at(int i) const
{
    assert((i >= 0) && (i < length));
    return elements[i];
}

void SafeArray::set(int i, int value)
{
    assert((i >= 0) && (i < length));
    elements[i] = value;
}

SafeArray& SafeArray::operator =(const SafeArray& rhs)
{
    if (elements != nullptr) delete[] elements;

    length = rhs.length;
    elements = new int[length];

    for (int i = 0; i < length; i++)
    {
        elements[i] = rhs.elements[i];
    }

    return *this;
}
